import torch 

def einsum(S1, S2, S3, S4):
    return torch.einsum('war,abu,bgl,gwd->ruld', (S1, S2, S3, S4))

def tensordot(S1, S2, S3, S4):
    #T1 = torch.tensordot(S1, S2, dims=([1], [0]))
    #T2 = torch.tensordot(S3, S4, dims=([1], [0]))
    #return torch.einsum('wrbu,blwd->ruld', (T1, T2))
    return torch.tensordot( torch.tensordot(S1, S2, dims=([1], [0])), 
                            torch.tensordot(S3, S4, dims=([1], [0])), dims=([2, 0], [0, 2]))


if __name__=='__main__':
    import time
    D = 20
    D_new = 30

    S1 = torch.randn(D, D, D_new, dtype=torch.float64)
    S2 = torch.randn(D, D, D_new, dtype=torch.float64)
    S3 = torch.randn(D, D, D_new, dtype=torch.float64)
    S4 = torch.randn(D, D, D_new, dtype=torch.float64)

    t0 = time.time()
    T1 = einsum(S1, S2, S3, S4)
    print ('ensum time', time.time()-t0)

    t0 = time.time()
    T2 = tensordot(S1, S2, S3, S4)
    print ('tensordot time', time.time()-t0)

    print (T1.shape, T2.shape, (T1-T2).abs().sum())
    
